#!/usr/bin/ruby
include Math
require 'fileutils'

data_file = "data.txt"
plot_file = "plot.gp"

func    = ["sin", "cos", "tan"]
amp     = [1.0, 2.0, 3.0]
wavenum = [1.0, 2.0, 3.0]
phase   = [0.0, PI/4.0, PI/2.0, PI*3.0/4.0]


for iphase in 0..(phase.size-1)
  for iwavenum in 0..(wavenum.size-1)
    for iamp in 0..(amp.size-1)

      for ifunc in 0..(func.size-1)

        dir = "exp_" +
              "amp"   + sprintf( "%02d"  , amp[iamp]         ) + 
              "_wn"    + sprintf( "%02d"  , wavenum[iwavenum] ) + 
              "_phase" + sprintf( "%05.3f", phase[iphase]     )
        if Dir::exist?( dir ) then
        else
          Dir::mkdir( dir )
        end

        fig_file = "fig_" + func[ifunc] + ".png"

        file_content =<<~"EOF"
          set term png
          set output "#{fig_file}"
          set xlabel "x"
          set ylabel "y"
          set yrange [-4:4]
          plot #{amp[iamp]} * #{func[ifunc]}( #{wavenum[iwavenum]} * x - #{phase[iphase]} )
        EOF
        f = File.open( plot_file, "w" )
        f.puts file_content
        f.close

        com = "gnuplot plot.gp"
        system( com )
        FileUtils.mv( fig_file, dir )

      end
    end
  end
end

